 /*----------------------------------------------------------------
   Sample program lxitayl_ex1.cpp for extended staggered Taylor 
   arithmetic. Calculating guaranteed inclusions of the derivatives 
   of the function  f = x / (1+x^2) in interval staggered arithmetic.
  -----------------------------------------------------------------*/

#include "lxitaylor.hpp"   // Header file for class lx_itaylor
#include "lx_interval.hpp" // Extended interval staggered arithmetic
#include <iostream>        // Input, output

using namespace std;
using namespace taylor;
using namespace cxsc;

int main()
{
    stagprec = 30;  // Provides a precision of about 30*16 
                    // decimal digits.
    int p = 80;     // Taylor expansion of order p
	 lx_interval h;
	 // l_interval li;
	 string s;
	 
	 h = lx_interval(-2,l_interval(1));   // h includes 0.25;
    //  h = lx_interval(-1,"[11,11]")/4; // h includes 1.1/4;
    //  h = lx_interval(-3,"[11,11]"); // h includes 10^(-2)*1.1;
	 h = 1 + lx_interval(-1500,l_interval(1));
	 // point interval h includes 1 + 2^(-1500);
    lx_itaylor x(p,h);  // Constructor call
    // Point of expansion: 1 + 2^(-1500) lies near the zero 1 of
	 // the first derivative.
    lx_itaylor f;
    //  f = x / (1+sqr(x));
	 f = 1/(x+1/x);  // Delivers maximum accuracy for 1st derivative!

    cout << SetDotPrecision(16*stagprec,16*stagprec) << Scientific;
	 h = get_j_derivative(f,1);
	 s << h;
	 cout << "1.  derivative: " << s << endl; // Delivers maximum internal
	                                  // accuracy and output with 2^(...);
	 cout << "1.  derivative: " << h << endl;     // Output with 10^(...);
    cout << "80. derivative: " << get_j_derivative(f,80) << endl;
}

